% fig4.m
% (makechan.m)
%
% Written by Rick Martin, 02/11/2004
% Last updated on 02/11/2004
% Cornell University Blind Equalization Research Group
%
% Copyright 2004 Cornell University, All Rights Reserved

%rand('state',state0); randn('state',state1);
state0 = rand('state'); state1 = randn('state');

nu = 16;               % CP length
tLh_mid = 32;          % delay spread of remote scatterers
tLh_local = 6;         % delay spread of each set of local scatterers
decay = 2;             % channel exponential decay rate

hmid = exp(-[1:tLh_mid].'/(tLh_mid/decay)) .* ...
   (randn(tLh_mid,1) + j*randn(tLh_mid,1));
hlocal1 = randn(tLh_local,1) + j*randn(tLh_local,1);
hlocal2 = randn(tLh_local,1) + j*randn(tLh_local,1);
h = conv(conv(hlocal1,hmid),hlocal2);
h = h/norm(h);
Lh = length(h)-1;

d = MaxWindow(h,nu+1);

figure(1); clf;
set(0,'DefaultAxesFontSize',16);
stem([0:Lh],abs(h));
hold on;
stem([d:d+nu],abs(h(d+1:d+nu+1)),'filled');
hold off;
vv = axis;
axis([0 Lh 0 vv(4)]);
xlabel('tap index','FontSize',16);
ylabel('tap magnitude','FontSize',16);
grid on;
